Выбирай : Покупай : Используй
0

Linux и BSD в опасности из-за «тривиальной» ошибки в коде

Простая в эксплуатации и трудноисправимая ошибка угрожает ряду дистрибутивов Linux и OpenBSD. Баг позволяет перезаписывать произвольные файлы и повышать привилегии в системе.

Некорректная валидация

Обнаружена «тривиальная» ошибка в X.Org Server, которая может привести к повышению привилегий пользователя в среде Linux и BSD до уровня root — так называемого суперпользователя. Баг, получивший идентификатор CVE-2018-14665, присутствовал в X.Org как минимум в течение двух лет. Правда, его эксплуатация возможна лишь при соблюдении нескольких условий.

X.Org Server представляет собой свободную реализацию сервера X Window System (оконной системы для построения графического интерфейса в UNIX-подобных ОС) с открытым исходным кодом.

Выявленная в нем ошибка определяется как «некорректная валидация параметра, введенного с командной строки». Злоумышленник получает возможность перезаписывать произвольные файлы.

Повышение привилегий возможно посредством использования аргумента «-modulepath» и установления небезопасного пути к модулям, загружаемым сервером X.Org. Произвольная перезапись файлов возможна с помощью аргумента «-logfile».

Ошибка в коде поставила под угрозу Linux и BSD

Эксплуатация уязвимости возможна непривилегированным пользователям в тех случаях, когда X server уже работает с повышенными привилегиями (активирован «setuid»). По всей видимости, баг присутствовал с версии X.Org 1.19.0.

На данный момент проблема затрагивает системы Debian, Ubuntu, Fedora, Red Hat Enterprise и CentOS.

Комментарий эксперта

«X.Org активно используется большим количеством дистрибутивов Linux и Unix-подобными системами, — говорит Олег Галушкин, директор по информационной безопасности компании SEC Consult Services. — Распространенность уязвимости ставит под серьезную угрозу огромное количество систем. При этом эксплуатировать эту уязвимость просто, а вот исправление, по крайней мере, под некоторые ОС, потребует существенных усилий. Скорее всего, это будет означать довольно продолжительное временное “окно”, в течение которого затронутые системы останутся уязвимыми».

Могли бы избежать неприятностей

Действительно, помимо многих других, X.Org используется в OpenBSD; 18 октября состоялся релиз версии 6.4, в которой уязвимость CVE-2018-14665 сохранилась, причем, как утверждает создатель проекта OpenBSD Тео де Раадт (Theo De Raadt), оператор X.Org знал о проблеме самое позднее уже 11 октября, но почему-то не уведомил разработчиков OpenBSD об этом. Информацию они получили только 25 октября, за один час до официальной публикации сведений о баге.

В результате разработчикам OpenBSD пришлось выпускать отдельный патч вместо того, чтобы задержать релиз и выпустить систему уже исправленной. Патч требует рекомпиляции X server. В качестве промежуточного решения X.Org можно деактивировать с помощью команды chmod u-s /usr/X11R6/bin/Xorg.

Глава компании, занимающейся вопросами информационной безопасности, Hacker House Мэттью Хики (Matthew Hickey) уже опубликовал эксплойт, позволяющий эксплуатировать уязвимость через удаленную сессию SSH. По словам Хики, злоумышленнику достаточно «трех команд», чтобы захватить контроль над машиной. Позднее он представил вариант эксплойта для повышения привилегий, который умещается в одну строку.

 Распечатать
Комментарии